import urllib.request
import urllib.error
import json

class GenericRestAPI:

    def __init__(self, port):
        self.ipaddress = "127.0.0.1"
        self.port = port

    def get(self, url):
        url = "http://{}:{}{}".format(self.ipaddress, self.port, url)
        request = urllib.request.Request(url= url, method='GET')
        try:
            r = urllib.request.urlopen(request)
            if r.status == 200:
                info = r.read()
                enc = r.info().get_content_charset('utf-8')
                json_out = json.loads(info.decode(enc))
                return json_out
            else:
                return r.reason
        except urllib.error.URLError as e:
            print(e.reason)

    def post(self, url, payload):
        url = "http://{}:{}{}".format(self.ipaddress, self.port, url)
        request = urllib.request.Request(url= url, data=json.dumps(payload).encode('utf-8') ,method='POST')
        try:
            r = urllib.request.urlopen(request)
            return r.status
        except urllib.error.URLError as e:
            print(e.reason)

    def put(self, url, payload):
        url = "http://{}:{}{}".format(self.ipaddress, self.port, url)
        request = urllib.request.Request(url= url, data=json.dumps(payload).encode('utf-8') ,method='PUT')
        try:
            r = urllib.request.urlopen(request)
            return r.status
        except urllib.error.URLError as e:
            print(e.reason)

if __name__=="__main__":
    print("Test Generic Rest API")
    api = GenericRestAPI(8080)
    print("Get config")
    print(api.get('/api/config'))
    print("Get ptp config")
    print(api.get('/api/ptp/config'))
    print("Set ptp config")
    payload = {'domain': 1, 'dscp': 48}
    print(api.post('/api/ptp/config',payload))
    print("Get ptp config")
    print(api.get('/api/ptp/config'))
